/** @file HL_sys_main.c 
*   @brief Application main file
*   @date 11-Dec-2018
*   @version 04.07.01
*
*   This file contains an empty main function,
*   which can be used for the application.
*/

/* 
* Copyright (C) 2009-2018 Texas Instruments Incorporated - www.ti.com  
* 
* 
*  Redistribution and use in source and binary forms, with or without 
*  modification, are permitted provided that the following conditions 
*  are met:
*
*    Redistributions of source code must retain the above copyright 
*    notice, this list of conditions and the following disclaimer.
*
*    Redistributions in binary form must reproduce the above copyright
*    notice, this list of conditions and the following disclaimer in the 
*    documentation and/or other materials provided with the   
*    distribution.
*
*    Neither the name of Texas Instruments Incorporated nor the names of
*    its contributors may be used to endorse or promote products derived
*    from this software without specific prior written permission.
*
*  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS 
*  "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT 
*  LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
*  A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT 
*  OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, 
*  SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT 
*  LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
*  DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
*  THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
*  (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE 
*  OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
*
*/


/* USER CODE BEGIN (0) */
/* USER CODE END */

/* Include Files */

#include "HL_sys_common.h"
#include "HL_system.h"

/* USER CODE BEGIN (1) */
#include "HL_rti.h"
#include "HL_het.h"
#include "HL_esm.h"
#include "HL_gio.h"
/* USER CODE END */

/* USER CODE BEGIN (2) */
#define True 1
#define False 0

int ctr = 0;
boolean WatchDog_NMI = False;
/* USER CODE END */

void main(void)
{
/* USER CODE BEGIN (3) */
    /* Enable interrupt */
    //_enable_IRQ();
    _enable_interrupt_();
    gioInit();
    /* Initialize RTI */
    rtiInit();
    /* Enable RTI compare 0 notification */
    rtiEnableNotification(rtiREG1, rtiNOTIFICATION_COMPARE0);
    /* Start counter */
    rtiStartCounter(rtiREG1, rtiCOUNTER_BLOCK0);
    /* Initialize and start DWD */
    dwwdInit(rtiREG1, Generate_NMI, 4095, Size_100_Percent);
    dwdCounterEnable(rtiREG1);
    /* DWD is serviced in the RTI interrupt*/
    /* Delay */
    while(ctr < 5);
    /* Stop Servicing DWD */
    rtiDisableNotification(rtiREG1, rtiNOTIFICATION_COMPARE0);
    while(1);

/* USER CODE END */
}

/* USER CODE BEGIN (4) */
void rtiNotification(rtiBASE_t *rtiREG, uint32 notification)
{
    ctr++;
    gioToggleBit(gioPORTB,6);
    gioToggleBit(gioPORTB,7);
    dwdReset(rtiREG1);
}

void esmGroup2Notification(esmBASE_t *esm, uint32 channel)
{
    if(channel == 24)
    {
        WatchDog_NMI = True;
    }
}
/* USER CODE END */
